<?php

namespace UserBundle\Repository;

use Psr\Log\LoggerInterface;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use UserBundle\Entity\ExternalLinkStructure;
use Utils\StaticUtil\LogUtils;

/**
 * ExternalLinkStructureRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ExternalLinkStructureRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * ExternalLinkStructureRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, ExternalLinkStructure::class);
        $this->logger = $logger;
    }

    /**
     * @return array|mixed
     */
    public function findAllExternalLinkStructures () {
        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('els')
            ->from('UserBundle:ExternalLinkStructure', 'els')
            ->where('els.isDisabled=0')
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all link structures", $exception);
        }

        return $results;
    }

}
